"use strict";

exports.capture = capture;
exports.ref = ref;
var _encoder = require("../encoder/encoder.js");
var _elements = require("../utils/elements.js");
function capture(sequence, options) {
  return {
    type: 'capture',
    children: (0, _elements.ensureArray)(sequence),
    options,
    encode: encodeCapture
  };
}
function ref(name) {
  return {
    type: 'reference',
    name,
    encode: encodeReference
  };
}
function encodeCapture() {
  const name = this.options?.name;
  if (name) {
    return {
      precedence: 'atom',
      pattern: `(?<${name}>${(0, _encoder.encodeSequence)(this.children).pattern})`
    };
  }
  return {
    precedence: 'atom',
    pattern: `(${(0, _encoder.encodeSequence)(this.children).pattern})`
  };
}
function encodeReference() {
  return {
    precedence: 'atom',
    pattern: `\\k<${this.name}>`
  };
}
//# sourceMappingURL=capture.js.map