"use strict";

exports.negativeLookahead = negativeLookahead;
var _encoder = require("../encoder/encoder.js");
var _elements = require("../utils/elements.js");
function negativeLookahead(sequence) {
  return {
    type: 'negativeLookahead',
    children: (0, _elements.ensureArray)(sequence),
    encode: encodeNegativeLookahead
  };
}
function encodeNegativeLookahead() {
  return {
    precedence: 'atom',
    pattern: `(?!${(0, _encoder.encodeSequence)(this.children).pattern})`
  };
}
//# sourceMappingURL=negative-lookahead.js.map