"use strict";

exports.oneOrMore = oneOrMore;
exports.optional = optional;
exports.zeroOrMore = zeroOrMore;
var _encoder = require("../encoder/encoder.js");
var _elements = require("../utils/elements.js");
function zeroOrMore(sequence, options) {
  return {
    type: 'zeroOrMore',
    children: (0, _elements.ensureArray)(sequence),
    options,
    encode: encodeZeroOrMore
  };
}
function oneOrMore(sequence, options) {
  return {
    type: 'oneOrMore',
    children: (0, _elements.ensureArray)(sequence),
    options,
    encode: encodeOneOrMore
  };
}
function optional(sequence, options) {
  return {
    type: 'optional',
    children: (0, _elements.ensureArray)(sequence),
    options,
    encode: encodeOptional
  };
}
function encodeZeroOrMore() {
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}*${this.options?.greedy === false ? '?' : ''}`
  };
}
function encodeOneOrMore() {
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}+${this.options?.greedy === false ? '?' : ''}`
  };
}
function encodeOptional() {
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}?${this.options?.greedy === false ? '?' : ''}`
  };
}
//# sourceMappingURL=quantifiers.js.map