"use strict";

exports.repeat = repeat;
var _encoder = require("../encoder/encoder.js");
var _elements = require("../utils/elements.js");
function repeat(sequence, options) {
  const children = (0, _elements.ensureArray)(sequence);
  if (children.length === 0) {
    throw new Error('`repeat` should receive at least one element');
  }
  return {
    type: 'repeat',
    children,
    options,
    encode: encodeRepeat
  };
}
function encodeRepeat() {
  const atomicNodes = (0, _encoder.encodeAtom)(this.children);
  if (typeof this.options === 'number') {
    return {
      precedence: 'sequence',
      pattern: `${atomicNodes.pattern}{${this.options}}`
    };
  }
  return {
    precedence: 'sequence',
    pattern: `${atomicNodes.pattern}{${this.options.min},${this.options?.max ?? ''}}${this.options.greedy === false ? '?' : ''}`
  };
}
//# sourceMappingURL=repeat.js.map