import { encodeSequence } from "../encoder/encoder.mjs";
import { ensureArray } from "../utils/elements.mjs";
export function capture(sequence, options) {
  return {
    type: 'capture',
    children: ensureArray(sequence),
    options,
    encode: encodeCapture
  };
}
export function ref(name) {
  return {
    type: 'reference',
    name,
    encode: encodeReference
  };
}
function encodeCapture() {
  const name = this.options?.name;
  if (name) {
    return {
      precedence: 'atom',
      pattern: `(?<${name}>${encodeSequence(this.children).pattern})`
    };
  }
  return {
    precedence: 'atom',
    pattern: `(${encodeSequence(this.children).pattern})`
  };
}
function encodeReference() {
  return {
    precedence: 'atom',
    pattern: `\\k<${this.name}>`
  };
}
//# sourceMappingURL=capture.mjs.map